// import SDK from './jslib/main.da57a581'
import SDK from './jslib/sdk/static/js/main';
import AccessToken from './AccessToken';
import axios from 'axios'
//获取当前分页所需的实例个数
function getCurPageDom() {
    let doms;
    let pages = $(".page");
    for(let i = 0; i < pages.length; i++) {
        if(!$(pages[i]).is(':hidden')){
            doms = $(pages[i]).find('.sfu')
        }
    }
    return $(doms)
}

//订阅
function subscribe(sdkArr,index,mts) {
    for(let i=0; i < mts.length; i++) {
        if(i > 1) break;
        console.log("订阅的终端",index,mts[i])
        sdkArr[index].sdk.subscribe({
            userId: mts[i],
            dual: false
        })
    }
}

//显示画面
function showVideo(doms,index,sdkArr,data){
    let keylist = Object.keys(data);
    console.log('拿到的流列表Key',keylist)
    let videos = doms.eq(index).find('.sdk video');
    for(let i = 0; i < videos.length; i++) {
        if(keylist[i] && videos.eq(i).attr('id') != data[keylist[i]].streamid) {
            let stream = new MediaStream();
            stream.addTrack(data[keylist[i]].track)
            videos.eq(i)[0].srcObject = stream;
            videos.eq(i)[0].play();
            videos.eq(i).attr('id',data[keylist[i]].streamid);;
        }
        if(keylist[i] == null) {
            videos.eq(i)[0].srcObject = null;
            videos.eq(i).attr('id','')
        }
    }
}

//设置音频输入
function setDevice(doms,index,sdkArr,type,data) {
    let cur = '';
    let list = [];

    sdkArr[index].data['cur'+type] ? cur = sdkArr[index].data['cur'+type] : sdkArr[index].data['cur'+type] = '';
    sdkArr[index].data['list'+type] ? list = sdkArr[index].data['list'+type] : sdkArr[index].data['list'+type] = '';

    (data && data.cur && data.cur != '') ? cur = data.cur : '';
    (data && data.list) ? list = data.list : '';

    sdkArr[index].data['cur'+type] = cur; sdkArr[index].data['list'+type] = list; 

    let curName = '';
    let typeNme = '';
    switch (type){
        case 'audioInput':
            typeNme = '音频输入'; break;
        case 'videoInput':
            typeNme = '视频输入'; break;
        case 'audioOutput':
            typeNme = '音频输出'; break;
        default:
            console.log("may be error")
    }

    doms.eq(index).find('.'+type+' ul').html(''); 
    if(list.length > 0) {
        for(let i = 0; i < list.length; i++) {
            if(cur != '' && cur == list[i].deviceId) {
                curName = list[i].label
            }
            let li = $('<li><a id="' + list[i].deviceId + '">' + list[i].label + '</a></li>');
            doms.eq(index).find('.'+type+' ul').append(li)
        }
    }

    if(curName != '') {
        doms.eq(index).find('.'+type+' button').html(curName+'<span class="caret"></span>')
        doms.eq(index).find('.'+type+' button').attr("title",curName);
    }else {
        doms.eq(index).find('.'+type+' button').html('请选择设备<span class="caret"></span>')
        doms.eq(index).find('.'+type+' button').attr("title","请选择"+typeNme+"设备");
    }

}

//监听sdk事件
function bindSdkEvent(doms,sdkArr) {
    for(let i = 0; i < sdkArr.length; i++) {
        sdkArr[i].sdk.on('memtIdUpdate',(data) => {//自己的mtid
            console.log("memtIdUpdate",data)
            
        })
        sdkArr[i].sdk.on('mtlistOrderedListUpdate',(mts) => {//订阅列表更新
            console.log("mtlistOrderedListUpdate",mts)
            subscribe(sdkArr,i,mts)
        })
        sdkArr[i].sdk.on('meAudioinputDevicesUpdate',(data) => {//音频输入更新
            console.log("meAudioinputDevicesUpdate",data)
            setDevice(doms,i,sdkArr,'audioInput',{list: data})
        })
        sdkArr[i].sdk.on('meVideoinputDevicesUpdate',(data) => {//视频输入更新
            console.log("meVideoinputDevicesUpdate",data)
            setDevice(doms,i,sdkArr,'videoInput',{list: data})
        })
        sdkArr[i].sdk.on('meAudiooutputDevicesUpdate',(data) => {//音频输出更新
            console.log("meAudiooutputDevicesUpdate",data)
            setDevice(doms,i,sdkArr,'audioOutput',{list: data})
        })
        sdkArr[i].sdk.on('meCurrentAudioinputDeviceIdUpdate',(data) => {//当前音频输入更新
            console.log("meCurrentAudioinputDeviceIdUpdate",data)
            setDevice(doms,i,sdkArr,'audioInput',{cur: data})
        })
        sdkArr[i].sdk.on('meCurrentVideoinputDeviceIdUpdate',(data) => {//当前视频输入更新
            console.log("meCurrentVideoinputDeviceIdUpdate",data)
            setDevice(doms,i,sdkArr,'videoInput',{cur: data})
        })
        sdkArr[i].sdk.on('meCurrentAudiooutputDeviceIdUpdate',(data) => {//当前音频输出更新
            console.log("meCurrentAudiooutputDeviceIdUpdate",data)
            setDevice(doms,i,sdkArr,'audioOutput',{cur: data})
        })
        sdkArr[i].sdk.on('mediasConsumersUpdate',(data) => {//视频流更新
            console.log("mediasConsumersUpdate",data)
            showVideo(doms,i,sdkArr,data)
        })
    }
}

//初始化主动触发事件
function initButton(doms,sdkArr,meetingIdArr,userIdArr,appInfo) {
    /*
    *初始化配置
    */ 
    //初始化
    $('#root .init').on('click',function(){
        let hostname = $('#hostname').val();
        let id_one = $('#id_one').val();
        let id_two = $('#id_two').val();
        let id_three = $('#id_three').val();
        let id_four = $('#id_four').val();
        let userId_one = $('#userId_one').val();
        let userId_two = $('#userId_two').val();
        let userId_three = $('#userId_three').val();
        let userId_four = $('#userId_four').val();
        if(!(hostname&&hostname!=''&&
             id_one&&id_one!=''&&
             id_two&&id_two!=''&&
             id_three&&id_three!=''&&
             id_four&&id_four!=''&&
             userId_one&&userId_one!=''&&
             userId_two&&userId_two!=''&&
             userId_three&&userId_three!=''&&
             userId_four&&userId_four!=''
        )){
            return false
        }else {
            meetingIdArr.push(id_one,id_two,id_three,id_four)
            userIdArr.push(userId_one,userId_two,userId_three,userId_four)
            $('.init').attr('disabled','disabled')
            $('.baseNeed').html('初始化成功');
        }
        
        //登陆
        for(let i = 0; i < sdkArr.length; i++) {
            if(i < meetingIdArr.length) {
                sdkArr[i].sdk.init({
                    hostname: hostname,
                    isKrtcLogin: true,
                    success: function(){
                        console.log('-----------初始化成功-----------')
                        doms.find('.btn').removeAttr('disabled')
                        setTimeout(function(){
                            sdkArr[i].sdk.join({
                                roomId: meetingIdArr[i]
                            })
                        },5000)
                    },
                    error: function(){
                        sdkArr[i].sdk.krtcLogin({
                            nickname: 'test' + i,
                            appToken: new AccessToken(appInfo?.app_id,appInfo?.app_secret).build(userIdArr[i],1000*60),
                            hostname: hostname,
                            userId: userIdArr[i],
                            autoSubAllVideoStream: true,
                            success: function(){
                                console.log('-----------初始化成功-----------')
                                doms.find('.btn').removeAttr('disabled')
                                setTimeout(function(){
                                    sdkArr[i].sdk.join({
                                        roomId: meetingIdArr[i]
                                    })
                                },5000)
                            },
                            error: function(){
                                console.log('-----------初始化失败-----------')
                            }
                        })
                    }
                })
            }
        }

    })

    for(let i = 0; i < doms.length; i++) {
        //摄像头事件
        doms.eq(i).find(".openVideo").on('click',function(){
            sdkArr[i].sdk.enableCamera()
        })
        doms.eq(i).find(".closeVideo").on('click',function(){
            sdkArr[i].sdk.disableCamera()
        })
        //插话
        doms.eq(i).find(".insert").on('click',function(e){
            if($(e.target).text().search("取消") != -1) {
                sdkArr[i].sdk.disableMicrophone()
                $(e.target).text("插话")
                $(e.target).removeClass("btn-danger").addClass("btn-primary")
            }else {
                sdkArr[i].sdk.enableMicrophone()
                $(e.target).text("取消插话")
                $(e.target).removeClass("btn-primary").addClass("btn-danger")
            }
        })
        //设备切换事件
        doms.eq(i).find('.audioInput .dropdown-menu').on('click', 'li', function(e){
            let deviceid = $(e.target).attr('id');
            console.log("切换设备ID",deviceid)
            sdkArr[i].sdk.changeMicrophone({
                deviceId: deviceid
            })
        })
        doms.eq(i).find('.audioOutput .dropdown-menu').on('click', 'li', function(e){
            let deviceid = $(e.target).attr('id');
            console.log("切换设备ID",deviceid)
            sdkArr[i].sdk.changeLoudspeaker({
                deviceId: deviceid
            })
        })
        doms.eq(i).find('.videoInput .dropdown-menu').on('click', 'li', function(e){
            let deviceid = $(e.target).attr('id');
            console.log("切换设备ID",deviceid)
            sdkArr[i].sdk.changeCamera({
                deviceId: deviceid
            })
        })
        //全屏事件
        doms.eq(i).find('.sdk').on('dblclick',function(e){
            if(!isFullscreen()) {
                console.log("全屏打开")
                $('.drop').addClass('dropup')
                fullScreen($(this).parent()[0]);
                window.fullScreen = $(this).parent()[0];
            }else{
                console.log("全屏关闭")
                fullExit($(this).parent()[0])
                $('.drop').removeClass('dropup')
            }
        })
    }
}

function fullScreen(element) {
	if (!element) {
		element = document.documentElement;
	}
	//IE 10及以下ActiveXObject
	if (window.ActiveXObject) {
		console.log("IE 10及以下ActiveXObject");
		let WsShell = new ActiveXObject("WScript.Shell");
		WsShell.SendKeys("{F11}");
	}
	//HTML W3C 提议
	else if (element.requestFullScreen) {
		console.log("HTML W3C 提议");
		element.requestFullScreen();
	}
	//IE11
	else if (element.msRequestFullscreen) {
		console.log("IE11");
		element.msRequestFullscreen();
	}
	// Webkit (works in Safari5.1 and Chrome 15)
	else if (element.webkitRequestFullScreen) {
		console.log("Webkit");
		element.webkitRequestFullScreen();
	}
	// Firefox (works in nightly)
	else if (element.mozRequestFullScreen) {
		console.log("Firefox");
		element.mozRequestFullScreen();
	}
};

function fullExit(element,callback) {
	if (!element) {
		element = document.documentElement;
	}
	//IE ActiveXObject
	if (window.ActiveXObject) {
		var WsShell = new ActiveXObject("WScript.Shell");
		WsShell.SendKeys("{F11}");
	}
	//HTML5 W3C 提议
	else if (element.requestFullScreen) {
		const a = document.exitFullscreen();
	}
	//IE 11
	else if (element.msRequestFullscreen) {
		const b = document.msExitFullscreen();
	}
	// Webkit (works in Safari5.1 and Chrome 15)
	else if (element.webkitRequestFullScreen) {
		const a = document.webkitCancelFullScreen();
	}
	// Firefox (works in nightly)
	else if (element.mozRequestFullScreen) {
		const a = document.mozCancelFullScreen();
	}
	if(typeof callback == "function" ){
		callback()
	}
}

function isFullscreen(){
	return document.fullscreenElement ||
		document.msFullscreenElement ||
		document.mozFullScreenElement ||
		document.webkitFullscreenElement || false;
}

//初始化
export function init() {
    let doms = getCurPageDom()
    var sdkArr = []
    window.sdkArr = sdkArr;
    //获取复用ID
    let idArr = SDK.getClientIds();
    //创建SDK数组
    for(let i = 0; i < doms.length; i++) {
        if(i < idArr.length) {
            sdkArr.push({sdk: new SDK({clientId: idArr[i]}),data:{}})
        }else {
            sdkArr.push({sdk: new SDK(),data:{}})
        }
    }

    // 220测试用meetingid
    // let meetingIdArr = ['6660105','6660106','6660107','6660108']
    let meetingIdArr = [];
    let userIdArr = [];

    bindSdkEvent(doms,sdkArr)
    axios.get('config.json').then(result=>{
        let appInfo = result.data
        initButton(doms,sdkArr,meetingIdArr,userIdArr,appInfo)
    }).catch(err=>{
        initButton(doms,sdkArr,meetingIdArr,userIdArr)
    })
    doms.find('.btn').attr('disabled','disabled')
    doms.find('.init').removeAttr('disabled')

}